<template>
    <div class="PostList p-8">
        <h2 class="font-medium text-2xl text-white mb-6">Sortable Post List</h2>
        <div class="relative">
          <draggable v-model="latestPostsOrder" v-bind="dragOptions" @end="onDrop" item-key="uniqueId">
            <template #item="{element, index}">
              <Post :postId="element.postId" :index="index" :length="latestPostsOrder.length" />
            </template>
          </draggable>
          <div :class="{'timeTravelOverlay-visible': isRewinding}" class="timeTravelOverlay">
            <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor">
              <path stroke-linecap="round" stroke-linejoin="round" d="M21 16.811c0 .864-.933 1.406-1.683.977l-7.108-4.061a1.125 1.125 0 0 1 0-1.954l7.108-4.061A1.125 1.125 0 0 1 21 8.689v8.122ZM11.25 16.811c0 .864-.933 1.406-1.683.977l-7.108-4.061a1.125 1.125 0 0 1 0-1.954l7.108-4.061a1.125 1.125 0 0 1 1.683.977v8.122Z" />
            </svg>
          </div>
        </div>
    </div>
  </template>
  
  <script>
  import draggable from 'vuedraggable';
  import { mapState, mapActions } from 'pinia';
  import { useHistoryStore } from '@/stores/HistoryStore';
  import Post from './Post.vue';

  export default {
    name: 'PostList',
    components: {
      draggable,
      Post,
    },
    props: {
      isRewinding: {
        type: Boolean,
        default: false,
      },
    },
    computed: {
      ...mapState(useHistoryStore, ['historyOfPostsOrder']),
      latestPostsOrder: {
        /**
         * @returns {object[]} - An array of objects containing the postId and uniqueId
        */
        get() {
          return this.historyOfPostsOrder[this.historyOfPostsOrder.length - 1];
        },
        /**
         * @param {object[]} value - An array of objects containing the postId and uniqueId
         * @returns {void}
        */
        set(value) {
          this.addPostsOrder(value);
        }
      },
    },
    methods: {
      ...mapActions(useHistoryStore, ['addPostsOrder', 'addCommit']),
      /**
       * @param {object} payload - A CustomEvent object produced by the vuedraggable library
       * @returns {void}
      */
      onDrop(payload) {
        if (payload.oldIndex === payload.newIndex) {
          return;
        }
        this.addCommit({
          uniqueId: this.generateUniqueId(),
          draggedPostId: Number(payload.item.id),
          oldIndex: payload.oldIndex,
          newIndex: payload.newIndex,
        });
      },
      /**
       * @returns {number} - A unique number
      */
      generateUniqueId() {
        return Math.floor(Date.now() * Math.random());
      },
    },
    data() {
      return {
        dragOptions: {
          animation: 100,
          disabled: false,
          ghostClass: 'ghost'
        },
      }
    }
  }
  </script>
  
  <style scoped>
  @keyframes moveX {
  0%,
  100% {
    left: 48%;
  }
  50% {
    left: 52%;
  }
}
  .timeTravelOverlay {
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba(255, 255, 255, 0.5);
    border-radius: 10px;
    transition: opacity 0.3s ease-in-out;
    opacity: 0;
    z-index: -1;
    visibility: hidden;
  }
  .timeTravelOverlay-visible {
    opacity: 1;
    z-index: 1;
    visibility: visible;
  }
  .timeTravelOverlay-visible svg {
    animation-play-state: running !important;
  }
  .timeTravelOverlay svg {
    display: inline-block;
    width: 64px;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    animation: moveX 1s infinite;
    animation-play-state: paused;
  }
  </style>